local ADDON, Package = ...

local Module = {}

--------------------------------------------------------------------------------
-- Medusa
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Predefine
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Reform
--------------------------------------------------------------------------------
local function seconds_to_time(value)
  if value >= 86400 then
    text = DAY_ONELETTER_ABBR:format(ceil(value / 86400))
  elseif value >= 7200 then
    text = HOUR_ONELETTER_ABBR:format(ceil(value / 3600))
  elseif value >= 60 then
    text = MINUTE_ONELETTER_ABBR:format(ceil(value / 60))
  else
    text = SECOND_ONELETTER_ABBR:format(value)
  end

  return text
end

--------------------------------------------------------------------------------
-- Utility
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- State
--------------------------------------------------------------------------------
local is_hooked = false

--------------------------------------------------------------------------------
-- Object
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Module
--------------------------------------------------------------------------------
function Module.AuraButton_UpdateDuration(...) Module.AuraButton_UpdateDuration_Stub(...) end
function Module.AuraButton_UpdateDuration_Stub() end
function Module.AuraButton_UpdateDuration_Enable(aura_button, time_left)
  if time_left > 3600 then
    aura_button.duration:SetText(seconds_to_time(time_left))
  end
end
function Module.AuraButton_UpdateDuration_Disable() end

function Module.enable()
  Module.AuraButton_UpdateDuration_Stub = Module.AuraButton_UpdateDuration_Enable

  if not is_hooked then
    is_hooked = true

    hooksecurefunc("AuraButton_UpdateDuration", Module.AuraButton_UpdateDuration)
  end
end

function Module.disable()
  Module.AuraButton_UpdateDuration_Stub = Module.AuraButton_UpdateDuration_Disable
end

--------------------------------------------------------------------------------
-- Export
--------------------------------------------------------------------------------
Package.IndicateAccurateBuffTime = Module