local ADDON, Package = ...

local Module = {}

--------------------------------------------------------------------------------
-- Medusa
--------------------------------------------------------------------------------
local is_table = Package.Kernel.is_table
local is_number = Package.Kernel.is_number

--------------------------------------------------------------------------------
-- Predefine
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Reform
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Utility
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- State
--------------------------------------------------------------------------------
local is_hooked = false

--------------------------------------------------------------------------------
-- Object
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Module
--------------------------------------------------------------------------------
function Module.handle(self)
  local _, item_link = self:GetItem()

  if item_link then
    local _, _, _, _, _, _, _, _, _, _, item_sell_price = GetItemInfo(item_link)
    local container = GetMouseFocus()
    local item_count = (is_table(container) and is_number(container.count)) and container.count or 1

    if self:IsShown() and self.shownMoneyFrames == nil and item_sell_price and item_sell_price > 0 and item_count > 0 then
      SetTooltipMoney(self, item_sell_price * item_count, "STATIC")
    end
  end

  self:Show()
end

function Module.OnTooltipSetItem(...) Module.OnTooltipSetItem_Stub(...) end
function Module.OnTooltipSetItem_Stub() end
function Module.OnTooltipSetItem_Enable(self) Module.handle(self) end
function Module.OnTooltipSetItem_Disable() end

function Module.SetHyperlink(...) Module.SetHyperlink_Stub(...) end
function Module.SetHyperlink_Stub() end
function Module.SetHyperlink_Enable(self) Module.handle(self) end
function Module.SetHyperlink_Disable() end

function Module.enable()
  Module.OnTooltipSetItem_Stub = Module.OnTooltipSetItem_Enable
  Module.SetHyperlink_Stub = Module.SetHyperlink_Enable

  if not is_hooked then
    is_hooked = true

    GameTooltip:HookScript("OnTooltipSetItem", Module.OnTooltipSetItem)
    ItemRefTooltip:HookScript("OnTooltipSetItem", Module.OnTooltipSetItem)
    ShoppingTooltip1:HookScript("OnTooltipSetItem", Module.OnTooltipSetItem)
    ShoppingTooltip2:HookScript("OnTooltipSetItem", Module.OnTooltipSetItem)

    hooksecurefunc(GameTooltip, "SetHyperlink", Module.SetHyperlink)
    hooksecurefunc(ItemRefTooltip, "SetHyperlink", Module.SetHyperlink)
  end
end

function Module.disable()
  Module.OnTooltipSetItem_Stub = Module.OnTooltipSetItem_Disable
  Module.SetHyperlink_Stub = Module.SetHyperlink_Disable
end

--------------------------------------------------------------------------------
-- Export
--------------------------------------------------------------------------------
Package.IndicateItemVendorPriceOnTooltip = Module