local ADDON, Package = ...

local Module = {}

--------------------------------------------------------------------------------
-- Medusa
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Predefine
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Reform
--------------------------------------------------------------------------------
local function get_quest_difficulty_color(level)
  local color = GetQuestDifficultyColor(level)

  return CreateColor(color.r, color.g, color.b)
end

--------------------------------------------------------------------------------
-- Utility
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- State
--------------------------------------------------------------------------------
local is_hooked = false

--------------------------------------------------------------------------------
-- Object
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Module
--------------------------------------------------------------------------------
function Module.TradeFrame_Update(...) Module.TradeFrame_Update_Stub(...) end
function Module.TradeFrame_Update_Stub() end
function Module.TradeFrame_Update_Enable()
  local target_level = UnitLevel("NPC")
  local target_class = select(2, UnitClass("NPC"))

  if target_level > 0 and target_class then
    local target_level = get_quest_difficulty_color(target_level):WrapTextInColorCode(target_level)
    local target_name = RAID_CLASS_COLORS[target_class]:WrapTextInColorCode(TradeFrameRecipientNameText:GetText())

    TradeFrameRecipientNameText:SetFontObject("GameFontNormalSmall")
    TradeFrameRecipientNameText:SetFormattedText("%s %s", target_level, target_name)
  end
end
function Module.TradeFrame_Update_Disable() end

function Module.enable()
  Module.TradeFrame_Update_Stub = Module.TradeFrame_Update_Enable

  if not is_hooked then
    is_hooked = true

    hooksecurefunc("TradeFrame_Update", Module.TradeFrame_Update)
  end
end

function Module.disable()
  Module.TradeFrame_Update_Stub = Module.TradeFrame_Update_Disable
end

--------------------------------------------------------------------------------
-- Export
--------------------------------------------------------------------------------
Package.IndicateTargetLevelAndClassColorInTrade = Module