local ADDON, Package = ...

local Module = {}
local Registry = {}

--------------------------------------------------------------------------------
-- Medusa
--------------------------------------------------------------------------------
local is_member = Package.Enum.is_member

--------------------------------------------------------------------------------
-- Predefine
--------------------------------------------------------------------------------
local PROXY = CreateFrame("Frame")

local UI_ERROR_MESSAGES = {
  STAND = {
    SPELL_FAILED_NOT_STANDING,
    ERR_CANTATTACK_NOTSTANDING,
    ERR_LOOT_NOTSTANDING
  },
  DISMOUNT = {
    SPELL_FAILED_NOT_MOUNTED,
    ERR_ATTACK_MOUNTED,
    ERR_NOT_WHILE_MOUNTED,
    ERR_TAXIPLAYERALREADYMOUNTED
  }
}

--------------------------------------------------------------------------------
-- Reform
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Utility
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- State
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Object
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Module
--------------------------------------------------------------------------------
function Module.enable()
  PROXY:RegisterEvent("UI_ERROR_MESSAGE")
  PROXY:SetScript("OnEvent", Module.on_event)
end

function Module.disable()
  PROXY:UnregisterEvent("UI_ERROR_MESSAGE")
  PROXY:SetScript("OnEvent", nil)
end

function Module.on_event(self, event, ...)
  Registry[event](self, ...)
end

--------------------------------------------------------------------------------
-- Registry
--------------------------------------------------------------------------------
function Registry.UI_ERROR_MESSAGE(self, error_type, message)
  if is_member(UI_ERROR_MESSAGES.STAND, message) then
    DoEmote("STAND")
  end

  if is_member(UI_ERROR_MESSAGES.DISMOUNT, message) then
    Dismount()
  end
end

--------------------------------------------------------------------------------
-- Export
--------------------------------------------------------------------------------
Package.PostureAfterActionAttempted = Module