local ADDON, Package = ...

local Module = {}
local Registry = {}

--------------------------------------------------------------------------------
-- Medusa
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Predefine
--------------------------------------------------------------------------------
local PROXY = CreateFrame("Frame")

--------------------------------------------------------------------------------
-- Reform
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Utility
--------------------------------------------------------------------------------
local function print_money(amount, message, color)
  local text = color:WrapTextInColorCode(message)
  local coin = GetCoinTextureString(amount):gsub(":0", ":-4")

  DEFAULT_CHAT_FRAME:AddMessage(text .. " " .. coin)
end

--------------------------------------------------------------------------------
-- State
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Object
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Module
--------------------------------------------------------------------------------
function Module.enable()
  PROXY:RegisterEvent("MERCHANT_SHOW")
  PROXY:SetScript("OnEvent", Module.on_event)
end

function Module.disable()
  PROXY:UnregisterEvent("MERCHANT_SHOW")
  PROXY:SetScript("OnEvent", nil)
end

function Module.on_event(self, event, ...)
  Registry[event](self, ...)
end

--------------------------------------------------------------------------------
-- Registry
--------------------------------------------------------------------------------
function Registry.MERCHANT_SHOW()
  local repair_all_cost, can_repair = GetRepairAllCost()

  if can_repair and GetMoney() >= repair_all_cost then
    RepairAllItems()

    print_money(repair_all_cost, REPAIR_ALL_ITEMS, NORMAL_FONT_COLOR)
  end
end

--------------------------------------------------------------------------------
-- Export
--------------------------------------------------------------------------------
Package.RepairWhenInteractMerchant = Module