local ADDON, Package = ...

local Module = {}

--------------------------------------------------------------------------------
-- Medusa
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Predefine
--------------------------------------------------------------------------------
local CHAT_FRAMES = {
  ChatFrame1 = ChatFrame1,
  ChatFrame2 = ChatFrame2,
  ChatFrame3 = ChatFrame3,
  ChatFrame4 = ChatFrame4,
  ChatFrame5 = ChatFrame5,
  ChatFrame6 = ChatFrame6,
  ChatFrame7 = ChatFrame7,
  ChatFrame8 = ChatFrame8,
  ChatFrame9 = ChatFrame9,
  ChatFrame10 = ChatFrame10
}

--------------------------------------------------------------------------------
-- Reform
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Utility
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- State
--------------------------------------------------------------------------------
local is_hooked = false

--------------------------------------------------------------------------------
-- Object
--------------------------------------------------------------------------------

--------------------------------------------------------------------------------
-- Module
--------------------------------------------------------------------------------
function Module.set_clamp_rect_insets_in_chat_frames(left, right, top, bottom)
  local frames = CHAT_FRAMES

  for _, frame in pairs(frames) do
    frame:SetClampRectInsets(left, right, top, bottom)
  end
end

function Module.FloatingChatFrame_UpdateBackgroundAnchors(...) Module.FloatingChatFrame_UpdateBackgroundAnchors_Stub(...) end
function Module.FloatingChatFrame_UpdateBackgroundAnchors_Stub() end
function Module.FloatingChatFrame_UpdateBackgroundAnchors_Enable(self)
  self:SetClampRectInsets(0, 0, 0, 0)
end
function Module.FloatingChatFrame_UpdateBackgroundAnchors_Disable() end

function Module.enable()
  Module.set_clamp_rect_insets_in_chat_frames(0, 0, 0, 0)

  Module.FloatingChatFrame_UpdateBackgroundAnchors_Stub = Module.FloatingChatFrame_UpdateBackgroundAnchors_Enable

  if not is_hooked then
    is_hooked = true

    hooksecurefunc("FloatingChatFrame_UpdateBackgroundAnchors", Module.FloatingChatFrame_UpdateBackgroundAnchors)
  end
end

function Module.disable()
  Module.set_clamp_rect_insets_in_chat_frames(-35, 35, 38, -50)

  Module.FloatingChatFrame_UpdateBackgroundAnchors_Stub = Module.FloatingChatFrame_UpdateBackgroundAnchors_Disable
end

--------------------------------------------------------------------------------
-- Export
--------------------------------------------------------------------------------
Package.UnclampChatFrame = Module